import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Amaze here.
 * 
 * @author Taylor Born
 * @version January 2010
 */
import java.util.*;
import java.awt.Color;
import java.awt.Font;
public class Amaze  extends World
{
    private Logo myLogo = new Logo();
    private boolean started = false;
    private ArrayList<String> myRows;
    private ArrayList<Point> myNext;
    private Point myPosition;
    private PointF tank;
    private ArrayList<Shot> myShots;
    private ArrayList<Soldier> mySoldiers;
    private ArrayList<PointF> myPrizes;
    private ArrayList<Mine> myMines;
    private GreenfootImage drone = new GreenfootImage("Drone.png");
    private GreenfootImage man = new GreenfootImage("Man.png");
    private GreenfootImage gold = new GreenfootImage("gold.png");
    private GreenfootImage missle = new GreenfootImage("shot.png");
    private GreenfootImage minePic = new GreenfootImage("Mine.png");
    private GreenfootImage mineRPic = new GreenfootImage("MineR.png");
    private GreenfootImage plane = new GreenfootImage("Jet.png");
    private GreenfootImage m = new GreenfootImage(man);
    private GreenfootImage rock = new GreenfootImage("bluerock.jpg");
    private GreenfootImage castle = new GreenfootImage("castle.png");
    private GreenfootImage igloo = new GreenfootImage("igloo.png");
    private GreenfootImage healthG = new GreenfootImage("HealthG.png");
    private GreenfootImage healthY = new GreenfootImage("HealthY.png");
    private GreenfootImage healthR = new GreenfootImage("HealthR.png");
    private ArrayList<String> myMap;
    private boolean pause;
    private boolean letGoPause;
    private int score;
    private float time;
    private boolean done;
    private int round;
    private int reload = 25;
    private int health;
    private int flyBy;
    private Mine bomb;
    private GreenfootImage pic = new GreenfootImage(450, 450);
    private static final int CODE_ID = 8;
    
    public Amaze()
    {
        super(450, 450, 1);
        setPaintOrder(CodeDisplay.class);
//         GreenfootImage back = new GreenfootImage(450, 450);
        pic.fill();
        setBackground(pic);
        CodeKeyUser.enter();
        Greenfoot.start();
    }
    public void newMaze()
    {
        rock.scale(100, 100);
        castle.scale(70, 70);
        igloo.scale(70, 70);
        myNext = new ArrayList<Point>();
        myNext.add(new Point((int)(Math.random() * 34) + 1, (int)(Math.random() * 27) + 1));
        myRows = new ArrayList<String>();
        mySoldiers = new ArrayList<Soldier>();
        myPrizes = new ArrayList<PointF>();
        myShots = new ArrayList<Shot>();
        myMap = new ArrayList<String>();
        myMines = new ArrayList<Mine>();
        health = 9;
        round++;
        if (round > 0) // 2
            flyBy = -300 - Greenfoot.getRandomNumber(500);
        for (int i = 0; i < 30; i++)
        {
            myRows.add("");
            myMap.add("");
            for (int k = 0; k < 37; k++)
            {
                if (myNext.get(0).equals(new Point(k, i)))
                    myRows.set(i, myRows.get(i) + "*");
                else
                    myRows.set(i, myRows.get(i) + "O");
                myMap.set(i, myMap.get(i) + ".");
            }
        }
        for (int i = 0; i < 5000 && i < myNext.size(); i++)
        {
            if (i == 1)
            {
                time = 360;
                myRows.set(myPosition.getY(), myRows.get(myPosition.getY()).substring(0, myPosition.getX()) + "!" + myRows.get(myPosition.getY()).substring(myPosition.getX() + 1));
                myNext.remove(myNext.size() - 1);
                myNext.remove(myNext.size() - 1);
            }
            myPosition = myNext.get(i);
            for (int k = 0; k < 1000; k++)
            {
                String compass = "";
                if (check(0, -1) && check(-1, -1) && check(1, -1) && check(0, -2) && check(-1, -2) && check(1, -2))
                    compass += "U";
                if (check(0, 1) && check(-1, 1) && check(1, 1) && check(0, 2) && check(-1, 2) && check(1, 2))
                    compass += "D";
                if (check(-1, 0) && check(-2, 0) && check(-1, -1) && check(-2, -1) && check(-1, 1) && check(-2, 1))
                    compass += "L";
                if (check(1, 0) && check(2, 0) && check(1, -1) && check(2, -1) && check(1, 1) && check(2, 1))
                    compass += "R";
                if (compass.equals(""))
                {
                    if (i > 0 && k > 2 && Greenfoot.getRandomNumber(2) == 1)
                        myPrizes.add(new PointF((float)myPosition.getX() + .5f - .07f, (float)myPosition.getY() + .5f - .07f));
                    k = 1000;
                }
                else
                {
                    int t = (int)(Math.random() * compass.length());
                    if (compass.substring(t, t + 1).equals("U"))
                        myPosition = new Point(myPosition.getX(), myPosition.getY() - 1);
                    else if (compass.substring(t, t + 1).equals("D"))
                        myPosition = new Point(myPosition.getX(), myPosition.getY() + 1);
                    else if (compass.substring(t, t + 1).equals("L"))
                        myPosition = new Point(myPosition.getX() - 1, myPosition.getY());
                    else
                        myPosition = new Point(myPosition.getX() + 1, myPosition.getY());
                }
                if (!myRows.get(myPosition.getY()).substring(myPosition.getX()).equals("!"))
                {
                    myRows.set(myPosition.getY(), myRows.get(myPosition.getY()).substring(0, myPosition.getX()) + "#" + myRows.get(myPosition.getY()).substring(myPosition.getX() + 1));
                    if (i > 0 && k % 16 == 0)
                        mySoldiers.add(new Soldier(new PointF(myPosition.getX(), myPosition.getY())));
                }
                myNext.add(myPosition);
            }
        }
//         for (String str : myRows)
//         {
//             System.out.println(str);
//         }
//         System.out.println(mySoldiers.size());
        tank = new PointF((float)myNext.get(0).getX(), (float)myNext.get(0).getY());
        pause = true;
        done = false;
        paint();
    }
    public void act()
    {
        if (myLogo != null)
        {
            if (!started && Greenfoot.mouseMoved(this))
            {
                addObject(myLogo, 225, 225);
                started = true;
            }
            if (myLogo != null)
                if (myLogo.done())
                {
                    removeObject(myLogo);
                    myLogo = null;
                    newMaze();
                }
        }
        else
        {
            if (!done)
            {
                if (Greenfoot.isKeyDown("m"))
                {
                    if (letGoPause)
                    {
                        if (pause)
                            pause = false;
                        else
                            pause = true;
                        letGoPause = false;
                    }
                }
                else
                    letGoPause = true;
                if (!pause)
                {
                    if (time > 0)
                        time -= .02;
                    else
                        done = true;
                    if (round > 0) // 2
                    {
                        flyBy++;
                        if (flyBy == 50)
                            bomb = new Mine(tank, Greenfoot.getRandomNumber(360));
                        else if (flyBy == 100)
                            flyBy = -300 - Greenfoot.getRandomNumber(500);
                        if (bomb != null)
                        {
                            bomb.age();
                            bomb.age();
                            if (bomb.getHealth() == 1 && bomb.getExplosion() == -50)
                            {
                                if (Math.sqrt(Math.pow(bomb.getPosition().getX() + .1f - tank.getX() - .5f, 2) + Math.pow(bomb.getPosition().getY() + .1f - tank.getY() - .5f, 2)) < 2f)
                                {
                                    health -= 3;
                                    if (health < 1)
                                        time = 0;
                                }
                                bomb.getHit();
                            }
                            else if (bomb.getHealth() == 0)
                                bomb = null;
                        }
                    }
                    PointF extra = new PointF(0, 0);
                    if (Greenfoot.isKeyDown("up"))
                    {
                        if (!getBackground().getColorAt(210, 205).equals(Color.BLACK) && !getBackground().getColorAt(240, 205).equals(Color.BLACK))
                            extra = new PointF(0, -.05f);
                    }
                    else if (Greenfoot.isKeyDown("down"))
                    {
                        if (!getBackground().getColorAt(210, 245).equals(Color.BLACK) && !getBackground().getColorAt(240, 245).equals(Color.BLACK))
                            extra = new PointF(0, .05f);
                    }
                    if (Greenfoot.isKeyDown("left"))
                    {
                        if (!getBackground().getColorAt(205, 210).equals(Color.BLACK) && !getBackground().getColorAt(205, 240).equals(Color.BLACK))
                            extra = new PointF(-.05f, extra.getY());
                    }
                    else if (Greenfoot.isKeyDown("right"))
                    {
                        if (!getBackground().getColorAt(245, 210).equals(Color.BLACK) && !getBackground().getColorAt(245, 240).equals(Color.BLACK))
                            extra = new PointF(.05f, extra.getY());
                    }
                    tank = new PointF(tank.getX() + extra.getX(), tank.getY() + extra.getY());
                    if (myRows.get((int)((tank.getY() + .5f) - ((tank.getY() + .5f) % 1))).substring((int)((tank.getX() + .5f) - ((tank.getX() + .5f) % 1)), (int)((tank.getX() + .5f) - ((tank.getX() + .5f) % 1)) + 1).equals("!"))
                        done = true;
                    reload--;
                    for (Soldier man : mySoldiers)
                    {
                        boolean trig = false;
                        for (int i = -25; i < 50; i += 25)
                        {
                            float y = man.getPosition().getY() + .15f - (float)Math.sin(Math.toRadians(man.getDirection() + i)) * .3f;
                            y -= y % 1;
                            float x = man.getPosition().getX() + .15f + (float)Math.cos(Math.toRadians(man.getDirection() + i)) * .3f;
                            x -= x % 1;
                            if (myRows.get((int)y).substring((int)x, (int)x + 1).equals("O"))
                            {
                                man.turn();
                                trig = true;
                            }
                        }
                        if (!trig)
                            man.move();
                        if (reload == 0)
                            myMines.add(new Mine(man.getPosition(), man.getDirection()));
                    }
                    if (reload == 0)
                        reload = 25;
                    for (int i = 0; i < myMines.size(); i++)
                    {
                        myMines.get(i).age();
                        if (myMines.get(i).getExplosion() == -50 && Math.sqrt(Math.pow(myMines.get(i).getPosition().getX() + .1f - tank.getX() - .5f, 2) + Math.pow(myMines.get(i).getPosition().getY() + .1f - tank.getY() - .5f, 2)) < .13)
                        {
                            health--;
                            if (health < 1)
                                time = 0;
                            myMines.get(i).getHit();
                        }
                        if (myMines.get(i).getHealth() == 0)
                        {
                            myMines.remove(myMines.get(i));
                            i--;
                        }
                    }
                    MouseInfo mouse = Greenfoot.getMouseInfo();
                    if (Greenfoot.mouseClicked(this))
                    {
                        myShots.add(new Shot(new PointF(tank.getX() + .5f, tank.getY() + .5f), ((int)(Math.toDegrees(Math.atan2(-(mouse.getY() - 225) , (mouse.getX() - 225))))), extra));
                    }
                    if (Greenfoot.mouseMoved(null))
                    {
                        m = new GreenfootImage(man);
                        m.rotate(((int)(Math.toDegrees(Math.atan2((mouse.getY() - 225) , (mouse.getX() - 225))))));
                    }
                    for (int i = 0; i < myShots.size(); i++)
                    {
                        float y = myShots.get(i).getPosition().getY() + .04f - (float)Math.sin(Math.toRadians(myShots.get(i).getDirection())) * .08f;
                        y -= y % 1;
                        float x = myShots.get(i).getPosition().getX() + .04f + (float)Math.cos(Math.toRadians(myShots.get(i).getDirection())) * .08f;
                        x -= x % 1;
                        boolean hit = false;
                        for (int k = 0; k < mySoldiers.size(); k++)
                        {
                            if (Math.sqrt(Math.pow(myShots.get(i).getPosition().getX() - mySoldiers.get(k).getPosition().getX() - .15f, 2) + Math.pow(myShots.get(i).getPosition().getY() - mySoldiers.get(k).getPosition().getY() - .15f, 2)) < .16)
                            {
                                mySoldiers.get(k).getHit();
                                if (mySoldiers.get(k).isDead())
                                {
                                    mySoldiers.remove(mySoldiers.get(k));
                                    score += 15;
                                }
                                k = mySoldiers.size();
                                myShots.remove(myShots.get(i));
                                i--;
                                hit = true;
                            }
                        }
                        if (!hit)
                        {
                            if (myRows.get((int)y).substring((int)x, (int)x + 1).equals("O"))
                            {
                                myShots.remove(myShots.get(i));
                                i--;
                            }
                            else
                                myShots.get(i).move();
                        }
                    }
                    for (int i = 0; i < myPrizes.size(); i++)
                    {
                        if (Math.sqrt(Math.pow(myPrizes.get(i).getX() - tank.getX() - .5f, 2) + Math.pow(myPrizes.get(i).getY() - tank.getY() - .5f, 2)) < .15)
                        {
                            myPrizes.remove(myPrizes.get(i));
                            i--;
                            score += 50;
                        }
                    }
                }
            }
            else
            {
                if (Greenfoot.isKeyDown("enter"))
                {
                    score += 75;
                    if (time < 1)
                    {
                        score = 0;
                        round = 0;
                    }
                    newMaze();
                }
            }
            paint();
        }
    }
    private void paint()
    {
        pic.setColor(Color.BLACK);
        pic.fill();
        for (int i = (int)tank.getY() - 3; i < (int)tank.getY() + 4; i++)
        {
            if (i > -1 && i < myRows.size())
            {
                for (int k = (int)tank.getX() - 3; k < (int)tank.getX() + 4; k++)
                {
                    if (k > -1 && k < myRows.get(0).length())
                    {
                        if (myRows.get(i).substring(k, k + 1).equals("O"))
                        {
                            pic.setColor(Color.BLACK);
                            pic.fillRect((int)((k - tank.getX()) * 100) + 225 - 50, (int)((i - tank.getY()) * 100) + 225 - 50, 100, 100);
                            if (i > (int)tank.getY() - 3 && i < (int)tank.getY() + 3 && k > (int)tank.getX() - 3 && k < (int)tank.getX() + 3)
                                myMap.set(i, myMap.get(i).substring(0, k) + "O" + myMap.get(i).substring(k + 1));
                        }
                        else if (myRows.get(i).substring(k, k + 1).equals("#"))
                        {
                            pic.drawImage(rock, (int)((k - tank.getX()) * 100) + 225 - 50, (int)((i - tank.getY()) * 100) + 225 - 50);
                            if (i > (int)tank.getY() - 3 && i < (int)tank.getY() + 3 && k > (int)tank.getX() - 3 && k < (int)tank.getX() + 3)
                                myMap.set(i, myMap.get(i).substring(0, k) + "#" + myMap.get(i).substring(k + 1));
                        }
                        else if (myRows.get(i).substring(k, k + 1).equals("*"))
                        {
                            pic.drawImage(rock, (int)((k - tank.getX()) * 100) + 225 - 50, (int)((i - tank.getY()) * 100) + 225 - 50);
                            pic.drawImage(igloo, (int)((k - tank.getX()) * 100) + 225 - 50 + 15, (int)((i - tank.getY()) * 100) + 225 - 50 + 15);
                            if (i > (int)tank.getY() - 3 && i < (int)tank.getY() + 3 && k > (int)tank.getX() - 3 && k < (int)tank.getX() + 3)
                                myMap.set(i, myMap.get(i).substring(0, k) + "*" + myMap.get(i).substring(k + 1));
                        }
                        else if (myRows.get(i).substring(k, k + 1).equals("!"))
                        {
                            pic.drawImage(rock, (int)((k - tank.getX()) * 100) + 225 - 50, (int)((i - tank.getY()) * 100) + 225 - 50);
                            pic.drawImage(castle, (int)((k - tank.getX()) * 100) + 225 - 50 + 15, (int)((i - tank.getY()) * 100) + 225 - 50 + 15);
                            if (i > (int)tank.getY() - 3 && i < (int)tank.getY() + 3 && k > (int)tank.getX() - 3 && k < (int)tank.getX() + 3)
                                myMap.set(i, myMap.get(i).substring(0, k) + "!" + myMap.get(i).substring(k + 1));
                        }
                    }
                }
            }
        }
        pic.setColor(Color.RED);
        for (Mine aMine : myMines)
        {
            if (aMine.getTick() < 10)
            {
                GreenfootImage temp = new GreenfootImage(mineRPic);
                temp.rotate(aMine.getDirection());
                pic.drawImage(temp, (int)((aMine.getPosition().getX() - tank.getX()) * 100) + 225 - 50 + 5, (int)((aMine.getPosition().getY() - tank.getY()) * 100) + 225 - 50 + 5);
            }
            else
            {
                GreenfootImage temp = new GreenfootImage(minePic);
                temp.rotate(aMine.getDirection());
                pic.drawImage(temp, (int)((aMine.getPosition().getX() - tank.getX()) * 100) + 225 - 50 + 5, (int)((aMine.getPosition().getY() - tank.getY()) * 100) + 225 - 50 + 5);
            }
            if (aMine.getExplosion() != -50)
            {
                pic.fillOval((int)((aMine.getPosition().getX() - tank.getX()) * 100) + 225 - 50 + 5 + aMine.getExplosion() / 2, (int)((aMine.getPosition().getY() - tank.getY()) * 100) + 225 - 50 + 5 + aMine.getExplosion() / 2, 21 - aMine.getExplosion(), 21 - aMine.getExplosion());
            }
        }
        for (Soldier p : mySoldiers)
        {
            GreenfootImage dr = new GreenfootImage(drone);
            dr.rotate(-p.getDirection());
            pic.drawImage(dr, (int)((p.getPosition().getX() - tank.getX()) * 100) + 225 - 50, (int)((p.getPosition().getY() - tank.getY()) * 100) + 225 - 50 - 2);
        }
        for (PointF token : myPrizes)
            pic.drawImage(gold, (int)((token.getX() - tank.getX()) * 100) + 225 - 50 - 2, (int)((token.getY() - tank.getY()) * 100) + 225 - 50 + 1);
        for (Shot bullet : myShots)
            pic.drawImage(missle, (int)((bullet.getPosition().getX() - tank.getX()) * 100) + 225 - 50, (int)((bullet.getPosition().getY() - tank.getY()) * 100) + 225 - 50);
        pic.drawImage(m, 209, 210);
        if (round > 0) // 2
        {
            if (bomb != null)
            {
                if (bomb.getExplosion() != -50)
                {
                    pic.setColor(Color.RED);
                    pic.drawOval((int)((bomb.getPosition().getX() - tank.getX()) * 100) + 225 - (int)((30 - bomb.getExplosion()) * 3.5) + 15, (int)((bomb.getPosition().getY() - tank.getY()) * 100) + 225 - (int)((30 - bomb.getExplosion()) * 3.5) + 15, (30 - bomb.getExplosion()) * 7, (30 - bomb.getExplosion()) * 7);
                }
                else
                    pic.drawImage(mineRPic, (int)((bomb.getPosition().getX() - tank.getX()) * 100) + 225 + 5, (int)((bomb.getPosition().getY() - tank.getY()) * 100) + 225 + 5);
            }
            if (flyBy > 0)
            {
                pic.drawImage(plane, 50 + flyBy * 3, -50 + flyBy * 5);
            }
        }
        for (int i = 0; i < health; i++)
        {
            if (i < 2)
                pic.drawImage(healthR, 140 + 25 * i, 2);
            else if (i < 5)
                pic.drawImage(healthY, 140 + 25 * i, 2);
            else
                pic.drawImage(healthG, 140 + 25 * i, 2);
        }
        if (pause)
        {
            GreenfootImage map = new GreenfootImage(370, 300);
            for (int i = 0; i < myMap.size(); i++)
            {
                for (int k = 0; k < myMap.get(0).length(); k++)
                {
                    if (myMap.get(i).substring(k, k + 1).equals("O"))
                    {
                        map.setColor(Color.BLUE);
                        map.fillRect(k * 10, i * 10, 10, 10);
                    }
                    else if (myMap.get(i).substring(k, k + 1).equals("#"))
                    {
                        map.setColor(Color.WHITE);
                        map.fillRect(k * 10, i * 10, 10, 10);
                    }
                    else if (myMap.get(i).substring(k, k + 1).equals("."))
                    {
                        map.setColor(Color.GRAY);
                        map.fillRect(k * 10, i * 10, 10, 10);
                    }
                    else if (myMap.get(i).substring(k, k + 1).equals("*"))
                    {
                        map.setColor(Color.ORANGE);
                        map.fillRect(k * 10, i * 10, 10, 10);
                    }
                    else if (myMap.get(i).substring(k, k + 1).equals("!"))
                    {
                        map.setColor(Color.GREEN);
                        map.fillRect(k * 10, i * 10, 10, 10);
                    }
                }
            }
            map.setColor(Color.RED);
            map.fillOval((int)(tank.getX() * 10), (int)(tank.getY() * 10), 10, 10);
            map.setTransparency(150);
            pic.drawImage(map, 40, 75);
        }
        pic.setColor(Color.WHITE);
        pic.setFont(new Font("New Times Roman", 15, 15));
        pic.drawString("Score: " + score, 5, 20);
        if ((int)(time % 60) < 10)
            pic.drawString("Time  " + (int)(time / 60) + ":0" + (int)(time % 60), 5, 45);
        else
            pic.drawString("Time  " + (int)(time / 60) + ":" + (int)(time % 60), 5, 45);
        pic.drawString("Round: " + round, 5, 448);
        if (done)
        {
            GreenfootImage finish = new GreenfootImage(150, 50);
            finish.setColor(Color.GRAY);
            finish.fill();
            finish.setColor(Color.WHITE);
            finish.drawString("Press Enter", 15, 48);
            finish.setFont(new Font("New Times Roman", 15, 15));
            if (time > 0)
            {
                finish.drawString("Round " + round + " Complete!", 10, 20);
                if (CodeGenerator.haveUser())
                {
                    removeObjects(getObjects(CodeDisplay.class));
                    addObject(new CodeDisplay(CODE_ID), getWidth() / 2, getHeight() - 8);
                }
            }
            else if (health > 0)
                finish.drawString("You have froze!", 10, 20);
            else
                finish.drawString("You have died!", 10, 20);
            finish.setTransparency(150);
            pic.drawImage(finish, 200, 200);
        }
//         setBackground(pic);
    }
    private boolean check(int x, int y)
    {
        try
        {
            if (myRows.get(myPosition.getY() + y).substring(myPosition.getX() + x, myPosition.getX() + x + 1).equals("O"))
                return true;
            return false;
        }
        catch (Exception ex)
        {
            return false;
        }
    }
}